unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DXDraws, DIB, DXClass, StdCtrls;

type
  TForm1 = class(TForm)
    DXDraw: TDXDraw;
    il: TDXImageList;
    DXTimer: TDXTimer;
    Edit1: TEdit;
    cb1: TComboBox;
    Start: TButton;
    procedure DXTimerTimer(Sender: TObject; LagCount: Integer);
    procedure StartClick(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
  private
    { Private declarations }
  public
  procedure createmmap(Color:Tcolor;alpha:byte); // 
  end;

var
  Form1: TForm1;
  inaaa:boolean; //     
implementation

{$R *.dfm}

procedure Tform1.createmmap(Color:Tcolor;alpha:byte);
var
 NG : TDIB;
 Item: TPictureCollectionItem;
 tm:Tdirectdrawsurface;
 i:integer;
 est:boolean; //      
 TC:TColor;   //TransparentColor;
begin
  ng:=tdib.Create;     //  ()
  tm:=Tdirectdrawsurface.Create(DXDraw.Surface.DDraw); // 
  tm.SystemMemory:=false; //
  tm.SetSize(il.Items[0].Width,il.Items[0].height); //      
  tm.Fill(color); //   
  il.Items[0].DrawAlpha(tm,bounds(0,0,il.Items[0].width,il.Items[0].height),0,alpha); //      
  tm.AssignTo(ng); //    (  )
  tm.Free; //   
  TC:=ng.Canvas.Pixels[0,0];  //   0,0   Transparent
  est:=false; //  ,       
  for i:=0 to il.Items.Count-1 do //   
  if il.Items[i].Name='MMG' then //
  est:=true; //  
  if est then //  
  begin //   
  item:=il.Items.Find('MMG');
  Item.Picture.Graphic := ng;
  item.TransparentColor:=TC;
  item.Transparent:=true;
  Item.Restore;
  end
  else
  begin //  ,     !
  Item := TPictureCollectionItem.Create(IL.Items);
  Item.Name:='MMG';
  Item.SystemMemory:=false;
  Item.Picture.Graphic := ng;
  item.TransparentColor:=TC;
  item.Transparent:=true;
  Item.Restore;
  end;
end;


procedure TForm1.DXTimerTimer(Sender: TObject; LagCount: Integer);
begin
dxdraw.Surface.Fill(0);
il.Items.Find('img').Draw(dxdraw.Surface,0,0,0);
if inaaa then
il.Items.Find('mmg').Draw(dxdraw.Surface,80,0,0);
dxdraw.Flip;
end;

procedure TForm1.StartClick(Sender: TObject);
var cl:Tcolor;
begin
if cb1.Items[cb1.ItemIndex]='Black' then cl:=clBlack;
if cb1.Items[cb1.ItemIndex]='White' then cl:=clWhite;
if cb1.Items[cb1.ItemIndex]='Red' then cl:=clRed;
if cb1.Items[cb1.ItemIndex]='Green' then cl:=clGreen;
if cb1.Items[cb1.ItemIndex]='Blue' then cl:=clBlue;

cl := DXDraw.Surface.ColorMatch(cl);  //    DXDraw

createmmap(cl,strtoint(edit1.text)); //    
inaaa:=true;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
 if strtoint(edit1.text) >255 then edit1.text:='255';
 if strtoint(edit1.text) <0 then edit1.text:='0';
end;

end.
